/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.data;

import android.content.Context;
import android.database.Cursor;
import android.provider.ContactsContract.CommonDataKinds.Phone;
import android.provider.ContactsContract.Data;
import android.telephony.PhoneNumberUtils;
import android.util.Log;

import java.util.HashMap;

public class Contact { // 定义连接类
    private static HashMap<String, String> sContactCache; // 定义连接哈希表
    private static final String TAG = "Contact"; // 设置TAG的值为'连接'

    private static final String CALLER_ID_SELECTION = "PHONE_NUMBERS_EQUAL(" + Phone.NUMBER
            + ",?) AND " + Data.MIMETYPE + "='" + Phone.CONTENT_ITEM_TYPE + "'"
            + " AND " + Data.RAW_CONTACT_ID + " IN "
            + "(SELECT raw_contact_id "
            + " FROM phone_lookup"
            + " WHERE min_match = '+')"; // SQL语句

    public static String getContact(Context context, String phoneNumber) { // 获取连接
        if (sContactCache == null) {
            sContactCache = new HashMap<String, String>(); // 连接哈希表为空时创建连接哈希表
        }

        if (sContactCache.containsKey(phoneNumber)) {
            return sContactCache.get(phoneNumber); // 连接哈希表存在电话号码时获取值
        }

        String selection = CALLER_ID_SELECTION.replace("+",
                PhoneNumberUtils.toCallerIDMinMatch(phoneNumber)); // 将电话号码进行函数处理并代替'+'符号

        Cursor cursor = context.getContentResolver().query( // 用于查询的结果集
                Data.CONTENT_URI, // 通话记录uri
                new String[] { Phone.DISPLAY_NAME },
                selection,
                new String[] { phoneNumber },
                null); // 查询指定号码相关联系人名字

        if (cursor != null && cursor.moveToFirst()) {
            try { // 有结果时
                String name = cursor.getString(0); // 获取联系人名字
                sContactCache.put(phoneNumber, name); // 缓存电话号码与联系人名字
                return name;
            } catch (IndexOutOfBoundsException e) {
                Log.e(TAG, " Cursor get string error " + e.toString()); // 日志记录信息
                return null;
            } finally {
                cursor.close(); // 关闭结果集
            }
        } else {
            Log.d(TAG, "No contact matched with number:" + phoneNumber); // 日志记录信息
            return null; // 没找到，返回NULL
        }
    }
}
